package com.circuitengine.controller;

import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionListener;
import java.util.Iterator;

import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPopupMenu;
import javax.swing.event.MouseInputListener;

import com.circuitengine.model.TiePoint;
import com.circuitengine.model.Components.ACCurrentSource;
import com.circuitengine.model.Components.ACVoltageSource;
import com.circuitengine.model.Components.Ammeter;
import com.circuitengine.model.Components.Battery;
import com.circuitengine.model.Components.CapacitanceMeter;
import com.circuitengine.model.Components.Capacitor;
import com.circuitengine.model.Components.CurrentIntegrator;
import com.circuitengine.model.Components.CurrentSource;
import com.circuitengine.model.Components.ElectricComponent;
import com.circuitengine.model.Components.InductanceMeter;
import com.circuitengine.model.Components.Inductor;
import com.circuitengine.model.Components.Ohmmeter;
import com.circuitengine.model.Components.Resistor;
import com.circuitengine.model.Components.VoltageIntegrator;
import com.circuitengine.model.Components.Voltmeter;
import com.circuitengine.model.Components.Wire;
import com.circuitengine.view.ChangeACParametersFrame;
import com.circuitengine.view.ChangePrimaryValueFrame;
import com.circuitengine.view.CircuitEngineJFrame;
import com.circuitengine.view.CircuitEnginePanel;
import com.circuitengine.view.GraphFrame;
import com.circuitengine.view.PhasePlane;

/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class CircuitEngineMouseListener implements MouseMotionListener, MouseInputListener{
  CircuitEnginePanel myParentCircuitEnginePanel;

  public CircuitEngineMouseListener(final CircuitEnginePanel theParentCircuitEnginePanel) {
    myParentCircuitEnginePanel = theParentCircuitEnginePanel;
  }


  //@Override
  public void mouseDragged(MouseEvent theMouseEvent) {
    //System.out.println("dragged");
      myParentCircuitEnginePanel.waiting=true;
    synchronized(myParentCircuitEnginePanel.dp){
      //System.out.println("begin drag");
    // TODO make more elegant
    myParentCircuitEnginePanel.setMouseX(theMouseEvent.getX());
    myParentCircuitEnginePanel.setMouseY(theMouseEvent.getY());
    if (!myParentCircuitEnginePanel.getIsDrawing() &&
        myParentCircuitEnginePanel.getIsMovingPoint()) {
      handleDragPoint();
    } else if (!myParentCircuitEnginePanel.getIsDrawing() &&
               myParentCircuitEnginePanel.getIsMovingComponent()) {
      handleDragComponent();
    }
     //System.out.println("end dragged");
    }
    myParentCircuitEnginePanel.waiting=false;
  }
  
  public void determineHint() {
    if (!myParentCircuitEnginePanel.getIsDrawing() &&
        !myParentCircuitEnginePanel.getIsMovingPoint()) {
      if (myParentCircuitEnginePanel.nearTiePoint()) {
        myParentCircuitEnginePanel.hintNearTiePoint();
        myParentCircuitEnginePanel.myNearestComponent = null;
        // myParentCircuitEnginePanel.myNearestSwitch = null;
      } else if (myParentCircuitEnginePanel.nearSwitch()) {
        myParentCircuitEnginePanel.hintNearSwitch();
        myParentCircuitEnginePanel.myNearestComponent = null;
      } else if (myParentCircuitEnginePanel.nearComponent()) {
        myParentCircuitEnginePanel.hintNearComponent();
        // myParentCircuitEnginePanel.myNearestTiePoint=null;
      } else {
        myParentCircuitEnginePanel.myNearestComponent = null;
        myParentCircuitEnginePanel.myNearestTiePoint = null;
        myParentCircuitEnginePanel.setHintStarting();
      }
    }
  }
  //@Override
  public void mouseMoved(MouseEvent theMouseEvent) {
 //System.out.println("moved");
   
      //System.out.println("waiting");
      myParentCircuitEnginePanel.waiting=true;
    
    synchronized(myParentCircuitEnginePanel.dp){
    // System.out.println("moved");
    myParentCircuitEnginePanel.setMouseX(theMouseEvent.getX());
    myParentCircuitEnginePanel.setMouseY(theMouseEvent.getY());
    if (myParentCircuitEnginePanel.getIsDrawing()) {
      myParentCircuitEnginePanel.myTempComponent
          .moveEnd(myParentCircuitEnginePanel.nearestX(), myParentCircuitEnginePanel
              .nearestY());
    } else {
      determineHint();
    }
    myParentCircuitEnginePanel.repaint();
    }
    myParentCircuitEnginePanel.waiting=false;
  }

  //@Override
  public void mouseClicked(MouseEvent theMouseEvent) {
   
      myParentCircuitEnginePanel.waiting=true;
    
    synchronized(myParentCircuitEnginePanel.dp){
     //System.out.println("clicked");
    // TODO reduce redundancy
    if (theMouseEvent.getClickCount() == 1 && theMouseEvent.getButton() == MouseEvent.BUTTON1) {
      if (myParentCircuitEnginePanel.getIsMovingPoint()){
        //myParentCircuitEnginePanel.setIsMovingPoint(false);
      }
        
      if (!myParentCircuitEnginePanel.getIsDrawing() &&
          !myParentCircuitEnginePanel.getIsMovingPoint()&&
          !myParentCircuitEnginePanel.getIsMovingComponent()) {
        if (!myParentCircuitEnginePanel.nearTiePoint()&&myParentCircuitEnginePanel.nearSwitch()){
          //myParentCircuitEnginePanel.myNearestSwitch.flip();
          //myParentCircuitEnginePanel.repaint();
          return;
        }
        myParentCircuitEnginePanel.myNearestComponent = null;
        myParentCircuitEnginePanel.myNearestTiePoint = null;
        // clicked
        myParentCircuitEnginePanel.setIsDrawing(true);
        myParentCircuitEnginePanel.setHintDrawing();
        myParentCircuitEnginePanel.newTempComponent();
        myParentCircuitEnginePanel.repaint();
        // Click another point on the canvas to create a component, or click
        // cancel
        // g.fillOval((int)(x1+alpha*deltax-4),(int)(y1+beta*deltay-4), 8, 8);
      } else if (myParentCircuitEnginePanel.getIsDrawing()) {
        if (myParentCircuitEnginePanel.myTempComponent.badSize()) {
          return;
        }
        Point p = myParentCircuitEnginePanel.myTempComponent.head.getPosition();
        Point nearest =new Point (myParentCircuitEnginePanel.nearestX(),
                                  myParentCircuitEnginePanel.nearestY());
        if (myParentCircuitEnginePanel.myGridPoints.containsKey(nearest)
            &&myParentCircuitEnginePanel.myGridPoints.containsKey(p)&&
            myParentCircuitEnginePanel.myGridPoints.get(p)
            .isConnectedTo(myParentCircuitEnginePanel.myGridPoints.get(nearest))){
          return;
          
        }
        /*myParentCircuitEnginePanel.nearTiePoint();//required-side effects
        if (myParentCircuitEnginePanel.nearTiePoint()&&//##removed dec 23 08
            
            myParentCircuitEnginePanel.myGridPoints.containsKey(p)&&
            myParentCircuitEnginePanel.myGridPoints.get(p)
            .isConnectedTo(myParentCircuitEnginePanel.myNearestTiePoint)
            ){
          return;
        }*/
        /*if (myParentCircuitEnginePanel.nearTiePoint()
            &&!(myParentCircuitEnginePanel.myGridPoints.containsKey(p)&&
                myParentCircuitEnginePanel.myGridPoints.get(p)
                .isConnectedTo(myParentCircuitEnginePanel.myNearestTiePoint))){
          myParentCircuitEnginePanel.setIsDrawing(false);
          myParentCircuitEnginePanel.setHintStarting();
          myParentCircuitEnginePanel.addElectricComponent();
        }*/
        myParentCircuitEnginePanel.setIsDrawing(false);
        //myParentCircuitEnginePanel.setHintStarting();
        myParentCircuitEnginePanel.addElectricComponent();
        determineHint();
        myParentCircuitEnginePanel.repaint();
      }
    }else if (theMouseEvent.getClickCount() == 1 && theMouseEvent.getButton() == MouseEvent.BUTTON3){
      //System.out.println("hello");
      if (!myParentCircuitEnginePanel.getIsDrawing() &&
          !myParentCircuitEnginePanel.getIsMovingPoint()&&
          !myParentCircuitEnginePanel.getIsMovingComponent()) {
        if (myParentCircuitEnginePanel.nearTiePoint()){
          final Point point = myParentCircuitEnginePanel.myNearestTiePoint.getPosition();
          JPopupMenu jPopupMenu = new JPopupMenu();
          JMenuItem deleteMenuItem = new JMenuItem("Delete Tie Point");
          deleteMenuItem.addActionListener(new ActionListener() {
            public void actionPerformed(final ActionEvent e) {
              //System.out.println("delete");
              Iterator<ElectricComponent> i = myParentCircuitEnginePanel.myCircuit.electricComponents.iterator();
              while (i.hasNext()){
                ElectricComponent ec=i.next();
                if (ec.head.getPosition().equals(point)) {
                  ec.disconnectHeadAndTail();
                  i.remove();//myParentCircuitEnginePanel.myCircuit.electricComponents.remove(ec);
                  if (ec.tail.myConnectedTo.size() == 0) {
                    myParentCircuitEnginePanel.myGridPoints.remove(ec.tail.getPosition());
                  }
                } else if (ec.tail.getPosition().equals(point)) {
                  ec.disconnectHeadAndTail();
                  i.remove();//myParentCircuitEnginePanel.myCircuit.electricComponents.remove(ec);
                  if (ec.head.myConnectedTo.size() == 0) {
                    myParentCircuitEnginePanel.myGridPoints.remove(ec.head.getPosition());
                  }
                }
              }
              myParentCircuitEnginePanel.myGridPoints.remove(point);
              // jPopupMenu.setVisible(false);
            }
          });
          jPopupMenu.add(deleteMenuItem);
          jPopupMenu.show(myParentCircuitEnginePanel, myParentCircuitEnginePanel.getMouseX(),
                          myParentCircuitEnginePanel.getMouseY());
        }else if (myParentCircuitEnginePanel.nearComponent()){
          final ElectricComponent ec = myParentCircuitEnginePanel.myNearestComponent;
          JPopupMenu jPopupMenu = new JPopupMenu();
          if (ec.getClass()==Voltmeter.class||ec.getClass()==Ammeter.class
              ||ec.getClass()==CurrentIntegrator.class||ec.getClass()==VoltageIntegrator.class||ec.getClass()==Ohmmeter.class
              ||ec.getClass()==CapacitanceMeter.class||ec.getClass()==InductanceMeter.class){
            JMenuItem graphItem = new JMenuItem("Graph this "+ec.primary.substring(0, 1).toUpperCase()+ec.primary.substring(1));
            graphItem.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e){
           
                GraphFrame gf=new GraphFrame(myParentCircuitEnginePanel,0,0,ec.primary,ec.primaryUnitSymbol);
                ec.gf=gf;
                //JOptionPane.showMessageDialog(null, "Not available in demo");
              }
            });
            jPopupMenu.add(graphItem);
            
            JMenuItem phasePlaneYItem = new JMenuItem("Make this "+ec.primary.substring(0, 1).toUpperCase()
                                                     +ec.primary.substring(1)+" the Y-axis of a phase plane");
            phasePlaneYItem.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e){
         // /*demo  
                if (myParentCircuitEnginePanel.phasePlanes.size()==0
                     ||(myParentCircuitEnginePanel.phasePlanes.getLast().yComponent!=null
                         &&myParentCircuitEnginePanel.phasePlanes.getLast().xComponent!=null)){
                   PhasePlane phasePlane=new PhasePlane(myParentCircuitEnginePanel,0,0);
                   phasePlane.setY(ec);
                   myParentCircuitEnginePanel.phasePlanes.add(phasePlane);
                 }
                 else {//if (myParentCircuitEnginePanel.phasePlanes.getLast().xComponent==null){
                   myParentCircuitEnginePanel.phasePlanes.getLast().setY(ec);
                 }
          // */
          //      JOptionPane.showMessageDialog(null, "Not available in demo");
              }
            });
            jPopupMenu.add(phasePlaneYItem);
            
            JMenuItem phasePlaneXItem = new JMenuItem("Make this "+ec.primary.substring(0, 1).toUpperCase()
                                                     +ec.primary.substring(1)+" the X-axis of a phase plane");
            phasePlaneXItem.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e){
        // /*demo   
              if (myParentCircuitEnginePanel.phasePlanes.size()==0
                    ||(myParentCircuitEnginePanel.phasePlanes.getLast().yComponent!=null
                        &&myParentCircuitEnginePanel.phasePlanes.getLast().xComponent!=null)){
                   PhasePlane phasePlane=new PhasePlane(myParentCircuitEnginePanel,0,0);
                  phasePlane.setX(ec);
                  myParentCircuitEnginePanel.phasePlanes.add(phasePlane);
                }
                else {//if (myParentCircuitEnginePanel.phasePlanes.getLast().yComponent==null){
                  myParentCircuitEnginePanel.phasePlanes.getLast().setX(ec);
                }
         //  */
             //   JOptionPane.showMessageDialog(null, "Not available in demo");
              }
            });
            jPopupMenu.add(phasePlaneXItem);
          }
          if (ec.getClass()==Battery.class||ec.getClass()==Capacitor.class||ec.getClass()==Resistor.class||
              ec.getClass()==CurrentSource.class||ec.getClass()==Inductor.class){
            JMenuItem change = new JMenuItem("Change "+ec.primary);
            change.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e){
           
                new ChangePrimaryValueFrame(myParentCircuitEnginePanel,0,0,ec);
                //JOptionPane.showMessageDialog(null, "Not available in demo");
              }
            });
            jPopupMenu.add(change);
          }
          if (ec.getClass()==ACVoltageSource.class||ec.getClass()==ACCurrentSource.class){
            JMenuItem change = new JMenuItem("Adjust Paramaters");
            change.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e){
           
                new ChangeACParametersFrame(myParentCircuitEnginePanel,0,0,ec);
                //JOptionPane.showMessageDialog(null, "Not available in demo");
              }
            });
            jPopupMenu.add(change);
          }
          if (ec.getClass()==CurrentIntegrator.class||ec.getClass()==Capacitor.class
              ||ec.getClass()==Inductor.class||ec.getClass()==VoltageIntegrator.class){
            JMenuItem resetMenuItem = new JMenuItem("Reset "+ec.secondary+" to 0 "+ec.secondaryUnitSymbol);
            resetMenuItem.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e) {
                ec.secondaryValue=0;
                if (ec.getClass()==CurrentIntegrator.class){
                  CurrentIntegrator ci= (CurrentIntegrator)ec;
                  ci.chargeString="0.00 C";
                  myParentCircuitEnginePanel.repaint();
                }
                if (ec.getClass()==VoltageIntegrator.class){
                  VoltageIntegrator ci= (VoltageIntegrator)ec;
                  ci.magneticFluxString="0.00 Wb";
                  myParentCircuitEnginePanel.repaint();
                }
              }
            });
            jPopupMenu.add(resetMenuItem);
          }
          if (ec.getClass()!=Wire.class&&ec.getClass()!=Resistor.class){
            JMenuItem reverseOrientationMenuItem = new JMenuItem("Reverse Orientation");
            reverseOrientationMenuItem.addActionListener(new ActionListener(){
              public void actionPerformed(final ActionEvent e) {
                ec.reverse();
              }
            });
            jPopupMenu.add(reverseOrientationMenuItem);
          }
          JMenuItem deleteMenuItem = new JMenuItem("Delete Component");
          deleteMenuItem.addActionListener(new ActionListener() {
            public void actionPerformed(final ActionEvent e) {
              //System.out.println("delete");
              ec.disconnectHeadAndTail();
              if (ec.head.myConnectedTo.size()==0){
                myParentCircuitEnginePanel.myGridPoints.remove(ec.head.getPosition());
              }
              if (ec.tail.myConnectedTo.size()==0){
                myParentCircuitEnginePanel.myGridPoints.remove(ec.tail.getPosition());
              }
              myParentCircuitEnginePanel.myCircuit.electricComponents.remove(ec);
              // jPopupMenu.setVisible(false);
            }
          });
          jPopupMenu.add(deleteMenuItem);
          jPopupMenu.show(myParentCircuitEnginePanel, myParentCircuitEnginePanel.getMouseX(),
                          myParentCircuitEnginePanel.getMouseY());
        }
      }
    }
    }
    
      myParentCircuitEnginePanel.waiting=false;
    
  }

  //@Override
  public void mouseEntered(MouseEvent theMouseEvent) {
    // System.out.println("entered");
    myParentCircuitEnginePanel.setMouseEntered(true);
    myParentCircuitEnginePanel.repaint();
  }

  //@Override
  public void mouseExited(MouseEvent arg0) {
    myParentCircuitEnginePanel.setMouseEntered(false);
    if(!myParentCircuitEnginePanel.getIsDrawing() &&
        !myParentCircuitEnginePanel.getIsMovingPoint()&&
        !myParentCircuitEnginePanel.getIsMovingComponent()) {
      myParentCircuitEnginePanel.myNearestComponent = null;
      myParentCircuitEnginePanel.myNearestTiePoint = null;
      myParentCircuitEnginePanel.setHintStarting();
    }
    myParentCircuitEnginePanel.repaint();
    // System.out.println("exited");
  }

  //@Override
  public void mousePressed(MouseEvent theMouseEvent) {
    
      myParentCircuitEnginePanel.waiting=true;
    
    synchronized(myParentCircuitEnginePanel.dp){
    //System.out.println("pressed");
      if (theMouseEvent.getButton() == MouseEvent.BUTTON1) {
        myParentCircuitEnginePanel.setButtonState(true);
        if (!myParentCircuitEnginePanel.getIsDrawing() &&
            !myParentCircuitEnginePanel.getIsMovingPoint()&&
            !myParentCircuitEnginePanel.getIsMovingComponent()) {
          if (!myParentCircuitEnginePanel.nearTiePoint()&&myParentCircuitEnginePanel.nearSwitch()){
            myParentCircuitEnginePanel.myNearestSwitch.flip();
            myParentCircuitEnginePanel.repaint();
          }else if (myParentCircuitEnginePanel.nearTiePoint()) {
            myParentCircuitEnginePanel.setIsMovingPoint(true);
            myParentCircuitEnginePanel.myDraggedTiePoint =
                myParentCircuitEnginePanel.myNearestTiePoint;
          } else if (myParentCircuitEnginePanel.nearComponent()) {
            //myParentCircuitEnginePanel.nearTiePoint();//to set Nearest
            myParentCircuitEnginePanel.setIsMovingComponent(true);
            myParentCircuitEnginePanel.myDraggedComponent =
                myParentCircuitEnginePanel.myNearestComponent;
            myParentCircuitEnginePanel.myDraggedTiePoint =
                myParentCircuitEnginePanel.myNearestTiePoint;
          }
        }
      }
    }
    myParentCircuitEnginePanel.waiting=false;
    
  }

  //@Override
  public void mouseReleased(MouseEvent theMouseEvent) {
    
      myParentCircuitEnginePanel.waiting=true;
    
    synchronized(myParentCircuitEnginePanel.dp){
    if (theMouseEvent.getButton() == MouseEvent.BUTTON1) {
      myParentCircuitEnginePanel.setButtonState(false);
      if (myParentCircuitEnginePanel.getIsMovingPoint()) {
        //System.out.println("a"+myParentCircuitEnginePanel.myDraggedTiePoint.myConnectedTo.size());
        Point point =
            //new Point(myParentCircuitEnginePanel.nearestX(), myParentCircuitEnginePanel.nearestY());
              new Point(myParentCircuitEnginePanel.myDraggedTiePoint.getX(),
                        myParentCircuitEnginePanel.myDraggedTiePoint.getY());
        //System.out.println("aa"+myParentCircuitEnginePanel.myGridPoints.get(point).myConnectedTo.size());
        for (ElectricComponent e : myParentCircuitEnginePanel.myCircuit.electricComponents) {
          if (e.head == myParentCircuitEnginePanel.myDraggedTiePoint) {
            e.setHead(myParentCircuitEnginePanel.myGridPoints.get(point));
            //System.out.println("head");
          }else
          if (e.tail == myParentCircuitEnginePanel.myDraggedTiePoint) {
            e.setTail(myParentCircuitEnginePanel.myGridPoints.get(point));
            //System.out.println("tail");
          }
        }
        //System.out.println(myParentCircuitEnginePanel.myDraggedTiePoint.myConnectedTo.size());
        myParentCircuitEnginePanel.myDraggedTiePoint = null;
        myParentCircuitEnginePanel.myDraggedComponent=null;
        myParentCircuitEnginePanel.setIsMovingPoint(false);
        myParentCircuitEnginePanel.setIsMovingComponent(false);
      }else if (myParentCircuitEnginePanel.getIsMovingComponent()){
        myParentCircuitEnginePanel.myDraggedTiePoint = null;
        myParentCircuitEnginePanel.myDraggedComponent=null;
        myParentCircuitEnginePanel.setIsMovingPoint(false);
        myParentCircuitEnginePanel.setIsMovingComponent(false);
      }
      determineHint();
      myParentCircuitEnginePanel.repaint();
    }
     //System.out.println("released");
    }
    
      myParentCircuitEnginePanel.waiting=false;
    
  }

  public void handleDragPoint() {
    if (myParentCircuitEnginePanel.nearestX() != myParentCircuitEnginePanel.myDraggedTiePoint.getX()
        || myParentCircuitEnginePanel.nearestY() != myParentCircuitEnginePanel.myDraggedTiePoint.getY()) {
      Point point = new Point(myParentCircuitEnginePanel.nearestX(),
                              myParentCircuitEnginePanel.nearestY());
      Point oldPoint = new Point(myParentCircuitEnginePanel.myDraggedTiePoint.getX(),
                                 myParentCircuitEnginePanel.myDraggedTiePoint.getY());
      //System.out.println(point+" "+oldPoint);
      if (!myParentCircuitEnginePanel.myGridPoints.containsKey(point)) {//that is if we are dragging to an unoccupied location
        if (myParentCircuitEnginePanel.myGridPoints.get(oldPoint)
            == myParentCircuitEnginePanel.myDraggedTiePoint) {//that is, if there is no point left behind
          //System.out.println("123");
          myParentCircuitEnginePanel.myGridPoints.remove(oldPoint);
        }
        //System.out.println("567");
        myParentCircuitEnginePanel.myGridPoints
            .put(point, myParentCircuitEnginePanel.myDraggedTiePoint);
        myParentCircuitEnginePanel.myDraggedTiePoint.setX(myParentCircuitEnginePanel
            .nearestX());
        myParentCircuitEnginePanel.myDraggedTiePoint.setY(myParentCircuitEnginePanel
            .nearestY());
      } else {//if there is already a point here
        if (!myParentCircuitEnginePanel.myDraggedTiePoint
            .isConnectedTo(myParentCircuitEnginePanel.myGridPoints.get(point))&&
            !myParentCircuitEnginePanel.myDraggedTiePoint
            .isConnectedToOrder2(myParentCircuitEnginePanel.myGridPoints.get(point))) {//that is, if the new point at the new location isn't connectod to the old point
          // System.out.println("not connected");
          if (myParentCircuitEnginePanel.myGridPoints.get(oldPoint)
              == myParentCircuitEnginePanel.myDraggedTiePoint
              ) {//that is, if there is no point left behind after drag
            //myParentCircuitEnginePanel.myDraggedTiePoint=
            //System.out.println("removed old");
            myParentCircuitEnginePanel.myGridPoints.remove(oldPoint);
          }
          myParentCircuitEnginePanel.myDraggedTiePoint.setX(myParentCircuitEnginePanel
              .nearestX());
          myParentCircuitEnginePanel.myDraggedTiePoint.setY(myParentCircuitEnginePanel
              .nearestY());
        }
      }
      myParentCircuitEnginePanel.repaint();
    }
  }

  public void handleDragComponent() {
    if (myParentCircuitEnginePanel.nearestX() != myParentCircuitEnginePanel.myDraggedTiePoint.getX() ||
        myParentCircuitEnginePanel.nearestY() != myParentCircuitEnginePanel.myDraggedTiePoint.getY()) {
      //System.out.println("dragged comp");
      Point point = new Point(myParentCircuitEnginePanel.nearestX(),
                              myParentCircuitEnginePanel.nearestY());
      Point oldPoint = new Point(myParentCircuitEnginePanel.myDraggedTiePoint.getX(),
                                 myParentCircuitEnginePanel.myDraggedTiePoint.getY());
      TiePoint newTiePoint=new TiePoint(myParentCircuitEnginePanel.nearestX(),
                                        myParentCircuitEnginePanel.nearestY());
      if (myParentCircuitEnginePanel.nearTiePoint()){//must be called because this method has side effects
        //System.out.println("connected");
      }
      if (//myParentCircuitEnginePanel.myGridPoints.get(oldPoint)
          //== myParentCircuitEnginePanel.myDraggedTiePoint&&//if no point would be left behind
          myParentCircuitEnginePanel.myDraggedTiePoint.myConnectedTo.size()==1&&
          !(myParentCircuitEnginePanel.myGridPoints.containsKey(point)
            &&(  (myParentCircuitEnginePanel.myDraggedComponent.head==myParentCircuitEnginePanel.myDraggedTiePoint
                 &&(myParentCircuitEnginePanel.myDraggedComponent.tail==myParentCircuitEnginePanel.myNearestTiePoint
                    ||myParentCircuitEnginePanel.myDraggedComponent.tail.isConnectedTo(myParentCircuitEnginePanel.myNearestTiePoint))
                 )
                 ||(myParentCircuitEnginePanel.myDraggedComponent.tail==myParentCircuitEnginePanel.myDraggedTiePoint
                 &&(myParentCircuitEnginePanel.myDraggedComponent.head==myParentCircuitEnginePanel.myNearestTiePoint
                     ||myParentCircuitEnginePanel.myDraggedComponent.head.isConnectedTo(myParentCircuitEnginePanel.myNearestTiePoint))
                 )
              )
            )
          //!(myParentCircuitEnginePanel.myGridPoints.containsKey(point)&&
            //  (myParentCircuitEnginePanel.myDraggedTiePoint
             // .isConnectedTo(myParentCircuitEnginePanel.myGridPoints.get(point))||
             // myParentCircuitEnginePanel.myDraggedTiePoint
              //.isConnectedToOrder2(myParentCircuitEnginePanel.myGridPoints.get(point))))
          ){
        //System.out.println("r2");
        //System.out.prntln();
        myParentCircuitEnginePanel.myGridPoints.remove(oldPoint);
      }
        if (!myParentCircuitEnginePanel.myGridPoints.containsKey(point)){//that is if there is no point at this location yet
          myParentCircuitEnginePanel.myGridPoints.put(point, newTiePoint);//then put a point there
          if (myParentCircuitEnginePanel.myDraggedComponent.head==
            myParentCircuitEnginePanel.myDraggedTiePoint){//and set the location of the head
          myParentCircuitEnginePanel.myDraggedComponent
           .setHead(myParentCircuitEnginePanel.myGridPoints.get(point));
          myParentCircuitEnginePanel.myDraggedTiePoint=myParentCircuitEnginePanel.myDraggedComponent.head;
        }else{//or tail of the dragged component accordingly
          myParentCircuitEnginePanel.myDraggedComponent
          .setTail(myParentCircuitEnginePanel.myGridPoints.get(point));
          //myParentCircuitEnginePanel.myDraggedComponent.setTail(newTiePoint);
          myParentCircuitEnginePanel.myDraggedTiePoint=myParentCircuitEnginePanel.myDraggedComponent.tail;
        }
      }else{//if there is a point here already
      //myParentCircuitEnginePanel.myGridPoints.put(point, newTiePoint);
       // System.out.println("4");
        if(
            (myParentCircuitEnginePanel.myDraggedComponent.head==myParentCircuitEnginePanel.myDraggedTiePoint
             &&(myParentCircuitEnginePanel.myDraggedComponent.tail==myParentCircuitEnginePanel.myNearestTiePoint
                ||myParentCircuitEnginePanel.myDraggedComponent.tail.isConnectedTo(myParentCircuitEnginePanel.myNearestTiePoint)
               )
             )//if this is the head and is connectedorder2 to nearesttiepoint 
            ||(myParentCircuitEnginePanel.myDraggedComponent.tail==myParentCircuitEnginePanel.myDraggedTiePoint
               &&(myParentCircuitEnginePanel.myDraggedComponent.head==myParentCircuitEnginePanel.myNearestTiePoint
                  ||myParentCircuitEnginePanel.myDraggedComponent.head.isConnectedTo(myParentCircuitEnginePanel.myNearestTiePoint)
                  )
                )
            
            //myParentCircuitEnginePanel.myDraggedTiePoint
            //.isConnectedTo(myParentCircuitEnginePanel.myGridPoints.get(point))||
            //myParentCircuitEnginePanel.myDraggedTiePoint
            //.isConnectedToOrder2(myParentCircuitEnginePanel.myGridPoints.get(point))
            
           // myParentCircuitEnginePanel.myNearestTiePoint.isConnectedTo(
           // myParentCircuitEnginePanel.myDraggedTiePoint)||
            //myParentCircuitEnginePanel.myNearestTiePoint.isConnectedToOrder2(
             //myParentCircuitEnginePanel.myDraggedTiePoint)
            ){
               //System.out.println("connected");
               //System.out.println(myParentCircuitEnginePanel.myNearestTiePoint.getY());
               //System.out.println(myParentCircuitEnginePanel.myDraggedTiePoint.getY());
               return;//then don't do anything, we can't move here
             }
        //if we reach this point, it means that we are moving the component to a location that already has a point
        if (myParentCircuitEnginePanel.myDraggedComponent.head==
            myParentCircuitEnginePanel.myDraggedTiePoint){//if we're moving the head of draggedcomp
          myParentCircuitEnginePanel.myDraggedComponent
           .setHead(myParentCircuitEnginePanel.myGridPoints.get(point));//then move the head
          myParentCircuitEnginePanel.myDraggedTiePoint=myParentCircuitEnginePanel.myDraggedComponent.head;
        }else{
          myParentCircuitEnginePanel.myDraggedComponent
          .setTail(myParentCircuitEnginePanel.myGridPoints.get(point));
          //myParentCircuitEnginePanel.myDraggedComponent.setTail(newTiePoint);
          myParentCircuitEnginePanel.myDraggedTiePoint=myParentCircuitEnginePanel.myDraggedComponent.tail;
        }
      }
      myParentCircuitEnginePanel.myNearestTiePoint=myParentCircuitEnginePanel.myDraggedTiePoint;
      myParentCircuitEnginePanel.repaint();
    }
  
  }
}
