package com.circuitengine.view;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JToggleButton;
/*AUTHORS:

- Kevin Stueve (2009-12-20): initial published version
#*****************************************************************************
#       Copyright (C) 2009 Kevin Stueve kstueve@uw.edu
#
#  Distributed under the terms of the GNU General Public License (GPL)
#                  http://www.gnu.org/licenses/
#*****************************************************************************
*/
public final class ButtonPanel extends JPanel{
  private FlowLayout fl;
  static final String[] buttonNames = {"Resistor","Capacitor","Inductor","Battery","Current Source",
      "Wire","Voltmeter","Ammeter","Ohmmeter","Capacitance Meter","Inductance Meter","Switch"
      ,"Current Integrator","Voltage Integrator","AC Voltage Source","AC Current Source"};
  public ButtonPanel(final CircuitEnginePanel parentCircuitEnginePanel) {
    super();
    fl=new FlowLayout();
    this.setLayout(fl);
    this.add(new JLabel("Component: "));
    JComboBox componentList = new JComboBox(buttonNames);
    this.add(componentList);
    componentList.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e) {
        JComboBox cb = (JComboBox)e.getSource();
        String componentName = (String)cb.getSelectedItem();
        parentCircuitEnginePanel.setSelectedButton(componentName);
        parentCircuitEnginePanel.setIsDrawing(false);
        parentCircuitEnginePanel.setIsMovingPoint(false);
        parentCircuitEnginePanel.myHintPanel.startingHint();
        parentCircuitEnginePanel.repaint();
        parentCircuitEnginePanel.revalidate();
      }
    });
    componentList.setSelectedIndex(0);
    parentCircuitEnginePanel.setSelectedButton("Resistor");
    ButtonGroup pausePlayGroup = new ButtonGroup();
    JToggleButton pauseButton = new JToggleButton("Pause");
    JToggleButton playButton = new JToggleButton("Play");
    pausePlayGroup.add(pauseButton);
    pauseButton.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        parentCircuitEnginePanel.isPlaying=false;
      }
    });
    playButton.addActionListener(new ActionListener(){
      public void actionPerformed(ActionEvent e){
        parentCircuitEnginePanel.isPlaying=true;
      }
    });
    pausePlayGroup.add(playButton);
    playButton.doClick();
    this.add(pauseButton);
    this.add(playButton);
  }

}